/*
 *  ==============================================================================
 *  CircleShape.java: Create circle shapes with reference to DrawingAPI ...
 *  ==============================================================================
 */

package bridge01;

public class CircleShape extends Shape {
   private double x, y, radius;

   public CircleShape(double x, double y, double radius, DrawingAPI drawingAPI) {
      super(drawingAPI);
      this.x      = x;
      this.y      = y;
      this.radius = radius;
   }
 
   // Low-level i.e. Implementation specific

   public void draw() {
        drawingAPI.drawCircle(x, y, radius);
   }

   // High-level i.e. Abstraction specific

   public void resizeByPercentage(double pct) {
        radius *= pct;
   }
}
 
