/*
 *  =====================================================================
 *  RunBridgePattern.java: Exercise methods in the bridge design pattern.
 *  =====================================================================
 */

package bridge01;

public class RunBridgePattern {
   public static void main(String[] args) {

      // Create an array of circle shapes ....

      Shape s01 = new CircleShape( 1, 2,  3, new DrawingAPI1() );
      Shape s02 = new CircleShape( 5, 7,  5, new DrawingAPI2() );
      Shape s03 = new CircleShape( 1, 4, 11, new DrawingAPI1() );

      Shape[] shapes = new Shape[] { s01, s02, s03 };

      // Traverse array: resize and draw each shape item ...
 
      for (Shape shape : shapes) {
          shape.resizeByPercentage( 2.5 );
          shape.draw();
      }
   }
}
