
package builder01;

public class NutritionFactsWithBuilder {
   private final int servingSize;  
   private final int servings;     
   private final int calories;       
   private final int fat;            
   private final int sodium;       
   private final int carbohydrate; 

   // Builder class ...
	
   public static class Builder {

       // required parameters

       private final int servingSize;
       private final int servings;

       // optional parameters (initialized to default values)
		
       private int calories = 0;
       private int fat = 0;
       private int carbohydrate = 0;
       private int sodium = 0;

       // builder constructor method ...

       public Builder(int servingSize, int servings) {
          this.servingSize = servingSize;
          this.servings = servings;
       }

       // initialize optional parameters ..
	
       public Builder calories(int val) {
          calories = val;
	  return this;
       }
		
       public Builder fat(int val) {
          fat = val;
          return this;
       }
		
       public Builder carbohydrate(int val) {
          carbohydrate = val;
          return this;
       }
		
       public Builder sodium(int val) {
          sodium = val;
          return this;
       }
		
       public NutritionFactsWithBuilder build() {
          return new NutritionFactsWithBuilder(this);
       }
   }
	
   public NutritionFactsWithBuilder(Builder builder) {
      servingSize  = builder.servingSize;
      servings     = builder.servings;
      calories     = builder.calories;
      fat          = builder.fat;
      sodium       = builder.sodium;
      carbohydrate = builder.carbohydrate;
   }

   // Create string representation of nutrition facts ...

   @Override
   public String toString() {
      return "NutritionFactsWithBuilder [servingSize=" + servingSize + ", servings=" + servings + ", calories="
             + calories + ", fat=" + fat + ", sodium=" + sodium + ", carbohydrate=" + carbohydrate + "]";
   }
}
