/* 
 *  ============================================================================
 *  TestBuilderPattern.java: Exercise builder pattern ...
 *  
 *  Note the steps:
 *  
 *  --- Step 1: Get a builder object with required parameters
 *  --- Step 2: Setter like methods are used.They will set the optional fields also.
 *  --- Step 3: Invoke the constructCar() method to get the final car.
 *  
 *  ============================================================================
 */ 

package builder03;

public class TestBuilderPattern {
   public static void main(String[] args) {

      System.out.printf("Modified Builder Pattern Demo ...\n");
      System.out.printf("============================================  ...\n");

      // Create a custom car (through builder)

      System.out.printf ("--- Create a custom car (through builder) ...\n");

      ProductClass customCar1 = new CarBuilder().addHeadlights(5).insertWheels(5)
				.buildBody("Plastic").constructCar();

      // Make another custom car (through builder) with a different sequence and steps.

      System.out.printf ("--- Create a custom car (different sequence of builder steps) ...\n");

      ModifiedBuilder carBuilder2 = new CarBuilder();
      ProductClass customCar2 = carBuilder2.insertWheels(7).addHeadlights(6)
				.startUpOperations("I am making my own car")
                                .constructCar();		

      // Print details of custom car1 ....

      System.out.printf ("--- Print details of custom car 1  ...\n");

      System.out.println( customCar1 );

      // Print details of custom car2 ....

      System.out.printf ("--- Print details of custom car 1  ...\n");

      System.out.println( customCar2 );

      // Verifying the getConstructedCar() method

      System.out.printf ("--- Verify the getConstuctedCar() method ...\n");

      ProductClass customCar3 = carBuilder2.getConstructedCar();		

      System.out.println(customCar3);

      System.out.printf("============================================  ...\n");
   }
}
