/*
 *  =========================================================================
 *  DisplayCompositeMap.java: .....
 *  =========================================================================
 */

package composite02;

import java.awt.*;
import java.awt.Color;
import javax.swing.*;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.*;
import java.awt.Point;
import java.awt.event.*;
import java.util.*;

public class DisplayComposite {
   private DisplayCompositePanel canvas;
   private CompositeHierarchy      base;

   public DisplayComposite( CompositeHierarchy base ) {
      this.base = base;
   }

   // Create graphics screen ....

   public void display() {
       canvas = new DisplayCompositePanel( base );
       canvas.setBackground( Color.white );

       // Create a scroll pane and add the panel to it.

       JScrollPane scrollCanvas = new JScrollPane( canvas,
                   JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
                   JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
       scrollCanvas.setPreferredSize( new java.awt.Dimension(800, 800) );

       // Create buttons for panel along bottom of screen ...

       JPanel panel = new JPanel();
       panel.setLayout( new BorderLayout() );
       panel.add( scrollCanvas, BorderLayout.CENTER );

       JFrame frame = new JFrame("Display Composite Floorplan");
       frame.getContentPane().setLayout( new BorderLayout() );
       frame.getContentPane().add( panel );
       frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
       frame.setSize( 800, 800);
       frame.pack();
       frame.setVisible(true);
   }

   public void border() {
       canvas.drawBorder();
   }
}
