/* 
 *  ================================================================================
 *  Ellipse.java: Draw ellipse component. This is a leaf in the component hierarchy.
 *  ================================================================================
 */ 

package composite02;

import java.awt.*;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.*;
import java.awt.Point;
import javax.swing.*;

public class Ellipse implements Graphic {
    final static BasicStroke stroke = new BasicStroke(2.0f);  
    String sName;
    int x, y;

    public Ellipse ( String sName, int x, int y ) {
       this.sName  = sName;
       this.x = x;
       this.y = y;
    }

    public void draw( Graphics2D g2D ) {

       // Draw ellipse ....

       g2D.setStroke(stroke);
       g2D.draw(new Ellipse2D.Double(x, y, 20, 20));

       // Add label to ellipse ...

       g2D.scale( 1.0, -1.0 );
       g2D.drawString( sName, x, - 200);
       g2D.scale( 1.0, -1.0 );
    }
}
