/*
 * ======================================================================
 * TestComposite.java: Test program for drawing the exterior boundary and
 *                     layout of furniture in a dining room.
 * ======================================================================
 */
   
package composite02;

import java.util.ArrayList;
 
public class TestComposite {
    public static void main(String[] args) {
 
        // Initialize three composite graphics

        CompositeHierarchy base = new CompositeHierarchy( 0.0, 0.0, 0.0 );

        CompositeHierarchy eatingArea1 = new CompositeHierarchy(  50.0, 350.0, -Math.PI/2.0 );
        CompositeHierarchy eatingArea2 = new CompositeHierarchy( 300.0, 100.0,          0.0 );
        CompositeHierarchy eatingArea3 = new CompositeHierarchy( 250.0, 480.0,  Math.PI/2.0 );
        CompositeHierarchy eatingArea4 = new CompositeHierarchy( 300.0, 350.0,          0.0 );
 
        // Create polygon for room exterior ...

        ArrayList<Integer> x = new ArrayList();
        ArrayList<Integer> y = new ArrayList();

        x.add (  20 ); y.add ( 120 );
        x.add (  20 ); y.add ( 700 );
        x.add ( 300 ); y.add ( 700 );
        x.add ( 300 ); y.add ( 600 );
        x.add ( 500 ); y.add ( 600 );
        x.add ( 500 ); y.add ( 650 );
        x.add ( 700 ); y.add ( 650 );
        x.add ( 700 ); y.add ( 250 );
        x.add ( 600 ); y.add ( 250 );
        x.add ( 600 ); y.add (  20 );
        x.add ( 120 ); y.add (  20 );

        Polygon room = new Polygon(   0, 0, x, y );

        // Create table and chairs ...

        Box table  = new Box(   0,  50, 175, 100);
        Box chair1 = new Box(   0,   0,  25,  25);
        Box chair2 = new Box(  50,   0,  25,  25);
        Box chair3 = new Box( 100,   0,  25,  25);
        Box chair4 = new Box( 150,   0,  25,  25);
        Ellipse chair5 = new Ellipse("c1",   0, 175);
        Ellipse chair6 = new Ellipse("c2",  50, 175);
        Ellipse chair7 = new Ellipse("c3", 100, 175);
        Ellipse chair8 = new Ellipse("c4", 150, 175);

        // Define layout of table and chairs ....

        CompositeHierarchy tableandchairs = new CompositeHierarchy( 0.0, 0.0, 0.0 );
        tableandchairs.add (table);
        tableandchairs.add (chair1);
        tableandchairs.add (chair2);
        tableandchairs.add (chair3);
        tableandchairs.add (chair4);
        tableandchairs.add (chair5);
        tableandchairs.add (chair6);
        tableandchairs.add (chair7);
        tableandchairs.add (chair8);

        // Add table and chairs to eating areas ....

        eatingArea1.add( tableandchairs );
        eatingArea2.add( tableandchairs );
        eatingArea3.add( tableandchairs );
        eatingArea4.add( tableandchairs );

        // Compose the scene ....

        base.add(eatingArea1);
        base.add(eatingArea2);
        base.add(eatingArea3);
        base.add(eatingArea4);
        base.add(room);
 
        // Draw complete graphic starting at the base ...

        DisplayComposite display = new DisplayComposite( base );
        display.display();
    }
}
