package factory02;

public class TestAbstractFactory {
   public static void main(String[] args) {

      System.out.printf("Test Abstract Factory Operations ...\n"); 
      System.out.printf("============================================= ...\n"); 

      // Create factory for working with graphite pencils and erasers ...

      AbstractFactory factory = new GraphiteFactory();
      Pencil pencil = factory.createPencil();
      pencil.draw(); 
      Eraser eraser = factory.createEraser();
      eraser.erase(); 

      // Create factory for true color pencils and erasers ...
		
      AbstractFactory factoryT = new TrueColorFactory();
      Pencil pencilT = factoryT.createPencil();
      pencilT.draw(); 
      Eraser eraserT = factoryT.createEraser();
      eraserT.erase(); 

      System.out.printf("============================================= ...\n"); 
   }
}
