package mvc01;

import mvc01.model.*;
import mvc01.view.*;
import mvc01.controller.*;

public class ArchitectureExample {
   public static void main(String[] args) {
      System.out.printf("ArchitectureExample ...\n");
      System.out.printf("============================================= ...\n");

      // Create employee model ...

      System.out.printf("--- Create EmployeeModel() ...\n");

      Model model  = new EmployeeModel();
		
      // Create console view ...

      System.out.printf("--- Create ConsoleView() ...\n");

      View view = new ConsoleView();
		
      // Controller

      System.out.printf("--- Create EmployeeController() ...\n");

      Controller controller = new EmployeeController(model, view);

      System.out.printf("--- \n");
      System.out.printf("--- Display enrolled employees ...\n");
      System.out.printf("--- \n");

      controller.displayEnrolledEmployees();

      // Add an employee

      System.out.printf("--- \n");
      System.out.printf("--- Add employee: Kevin, E4 ..\n");
      System.out.printf("--- \n");

      controller.addEmployee(new Employee("Kevin","E4"));

      System.out.printf("--- \n");
      System.out.printf("--- Display enrolled employees ...\n");
      System.out.printf("--- \n");

      controller.displayEnrolledEmployees();

      // Remove employee E2 ...

      System.out.printf("--- \n");
      System.out.printf("--- Remove employee E2 ...\n");

      controller.removeEmployee("E2");
      controller.displayEnrolledEmployees();

      // Try to remove employee E5 (does not belong in list) ...

      System.out.printf("--- \n");
      System.out.printf("--- Remove employee E5 (does not exist) ...\n");

      controller.removeEmployee("E5");

      controller.displayEnrolledEmployees();
		
      // Avoiding duplicate entry

      System.out.printf("--- \n");
      System.out.printf("--- Add employee E4 again (avoid duplicate entries) ...\n");

      controller.addEmployee(new Employee("Kevin","E4"));
		
      // This segment is added to discuss a question in "Q&A Session"

      System.out.printf("--- \n");
      System.out.printf("--- Create MobileView() ...\n");

      view = new MobileView();

      controller = new EmployeeController(model, view);

      // Display employees in mobile view ...

      System.out.printf("--- Display employees in MobileView() ...\n");
      System.out.printf("--- \n");

      controller.displayEnrolledEmployees();

      System.out.printf("============================================= ...\n");
   }
}
