/*  
 *  ============================================================================
 *  Button.java: Simulate behavior of a button implemented as an active
 *  object. State behavior is defined as follows:
 * 
 *      Event State  --> push 
 *      ---------------------
 *               ON  -->  OFF 
 *              OFF  -->   ON
 *      ---------------------
 * 
 *  Written by: Mark Austin                                            July 2009
 *  ============================================================================
 */  

package state01;
                           
// The button class wraps the State behavior ....

public class Button {                
   private State current;
   public Button()                   { current = OFF.instance(); }
   public void setCurrent( State s ) { current = s; }
   public void push()                { current.push( this ); }
}
