/*
 *  ====================================================================
 *  Car.java: Composite specification for a car ....
 *
 *  Modified by: Mark Austin                                  June, 2012
 *  ====================================================================
 */

package visitor01;
 
public class Car implements CarElement {
    CarElement[] elements;

    // Car constructor methods ....
 
    public Car() {

        // Initialize details of car elements ...

        Wheel wheel01 = new Wheel("front left"); 
        wheel01.setPrice ( 1.0 );
        Wheel wheel02 = new Wheel("front right"); 
        wheel02.setPrice ( 1.0 );
        Wheel wheel03 = new Wheel("rear left"); 
        wheel03.setPrice ( 1.5 );
        Wheel wheel04 = new Wheel("rear left"); 
        wheel04.setPrice ( 1.5 );
        Body body    = new Body(); 
        body.setPrice ( 5.0 );
        Engine engine  = new Engine(); 
        engine.setPrice ( 5.0 );

        // Create an array of car elements

        this.elements = new CarElement[] { wheel01, wheel02, wheel03,
                                           wheel04,    body,  engine };
    }

    // Accept method for visiting elements ....
 
    public void accept( CarElementVisitor visitor ) {     

        // Systematically visit the car elements ....

        for(CarElement elem : elements) {
            elem.accept( visitor );
        }
 
        // Finally, visit the car itself ....

        visitor.visit(this);    
    }
}

