/*
 *  ====================================================================
 *  CarPriceVisitor.java: Visit car elements and compute price ...
 *
 *  Modified by: Mark Austin                                  June, 2012
 *  ====================================================================
 */

package visitor01;
 
public class CarPriceVisitor implements CarElementVisitor {
   private double totalPrice;    

   public void visit( Wheel wheel ) {      
      System.out.printf("Price: wheel  = %6.2f\n", wheel.getPrice() );
      totalPrice += wheel.getPrice();
   }
 
   public void visit( Engine engine ) {
      System.out.printf("Price: engine = %6.2f\n", engine.getPrice() );
      totalPrice += engine.getPrice();
   }
 
   public void visit( Body body ) {
      System.out.printf("Price: body   = %6.2f\n", body.getPrice() );
      totalPrice += body.getPrice();
   }
 
   public void visit( Car car ) {}

   // Return the internal state ....

   public double getTotalPrice() {
      return totalPrice;   
   }
}
