/*
 *  ======================================================================
 *  CompositeFindVisitor.java: Visit scene elements and find item having
 *  a given name.
 *
 *  Modified by: Mark Austin                                   March, 2016
 *  ======================================================================
 */

package visitor03.model;

import visitor03.model.*;
import visitor03.model.compound.*;
 
public class CompositeFindVisitor implements FeatureElementVisitor {
   private Feature item = null;    
   private String sName;    

   // Constructor methods ....

   public CompositeFindVisitor () {}

   public CompositeFindVisitor ( String sName ) {
      this.sName = sName;
   }

   // Methods for visiting various kinds of models ....

   public void visit( Tree tree ) {
      if( sName.equals( tree.getName() ) == true) {
         System.out.println("*** FOUND IT!!! ");
         item = (Feature) tree;
      }
   }

   public void visit( CarModel car ) {
      if( sName.equals( car.getName() ) == true) {
         System.out.println("*** FOUND IT!!! ");
         item = (Feature) car;
      }
   }

   public void visit( HouseModel house ) {
      if( sName.equals( house.getName() ) == true) {
         System.out.println("*** FOUND IT!!! ");
         item = (Feature) house;
      }
   }

   public void visit( AbstractFeature feature ) {}
   public void visit( CompositeHierarchy composite ) {}
   public void start( CompositeHierarchy composite ) {}
   public void finish( CompositeHierarchy composite ) {}

   // Set the name of item being searched for ....

   public void setFeatureName( String sName ) {
      this.sName = sName; 
   }

   // Return the internal state ....

   public Feature getFeature() {
      return item;   
   }
}
