/*
 *  ====================================================================
 *  FeatureElementVisitor.java: Interface for visiting elements of that
 *  have implemented the feature interface ...
 * 
 *  Modified by: Mark Austin                                  June, 2012
 *  ====================================================================
 */

package visitor03.model;

import visitor03.model.compound.*;

public interface FeatureElementVisitor {
    void visit(       Tree   tree );
    void visit(   CarModel    car );
    void visit( HouseModel  house );
    void visit( AbstractFeature      feature );
    void visit( CompositeHierarchy composite );
    void start( CompositeHierarchy composite );
    void finish( CompositeHierarchy composite );
}

