/*
 * ================================================================
 * Book.java: Simple model of a book ...
 * ================================================================
 */

package visitor04;

public class Book implements Visitable {
   private String isbn;
   private double quantity;
   private double price;

   // Constructor method ...

   public Book(String isbn, double quantity, double price) {
      this.isbn = isbn;
      this.quantity = quantity;
      this.price = price;
   }

   // Retrieve data from book model ...

   public String getISBN() {
      return isbn;
   }

   public double getQuantity() {
      return quantity;
   }

   public double getPrice() {
      return price;
   }

   // Accept method for visitors ...

   @Override
   public void accept( Visitor visitor ) {
      visitor.visit(this);
   }
}
