/*
 *  ===================================================================================
 *  TestShoppingCart.java: Fill shopping cart, then compute sales offer and total cost.
 *  ===================================================================================
 */

package visitor04;

public class TestShoppingCart {
    public static void main(String[] args) {

        // Part [a] -- Create an empty shopping cart ....

        ShoppingCart cart = new ShoppingCart();

        // Part [b] -- Create items that can be purchased ...

        Book      item01 = new Book( "BN-123", 10, 2.0 );
        Fruit     item02 = new Fruit( 5, 7.0 );
        Vegetable item03 = new Vegetable( 25, 8.0 );

        // Part [c] -- Add items to the cart ...

        cart.add( item01 );
        cart.add( item02 );
        cart.add( item03 );

        // Part [d] -- Print no items in shopping cart ...

        System.out.printf("*** =============================== ...\n" );
        System.out.printf("*** No items in shopping cart = %3d ...\n", cart.getNoItemsInCart() ); 
        System.out.printf("*** =============================== ...\n" );

        // Part [e] -- Print details of sales offer ...

        System.out.printf("*** Details of Sales Offer     ...\n" );
        System.out.printf("*** =============================== ...\n" );
   
        System.out.println( cart.calculateSalesOffer() );
        System.out.printf("*** =============================== ...\n" );

        // Part [f] -- Compute and print total cost ...

        System.out.printf("*** Total cost = %8.2f ...\n", cart.calculateTotalCost() );
        System.out.printf("*** =============================== ...\n" );
    }
}

